# osg::TexEnv Class Reference

TexEnv encapsulates the OpenGL glTexEnv (texture environment) state. More...

Inheritance diagram for osg::TexEnv:

[legend]
List of all members.

## Public Types

enum | Mode { DECAL = GL_DECAL, MODULATE = GL_MODULATE, BLEND = GL_BLEND, REPLACE = GL_REPLACE, ADD = GL_ADD }

## Public Member Functions

| TexEnv (Mode mode=MODULATE)
| TexEnv (const TexEnv &texenv, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| Copy constructor using CopyOp to manage deep vs shallow copy.
| META_StateAttribute (osg, TexEnv, TEXENV)
virtual bool | isTextureAttribute () const
| Return true if StateAttribute is a type which controls texturing and needs to be issued w.r.t to specific texture unit.
virtual int | compare (const StateAttribute &sa) const
| Return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs.
void | setMode (Mode mode)
Mode | getMode () const
void | setColor (const Vec4 &color)
Vec4 & | getColor ()
const Vec4 & | getColor () const
virtual void | apply (State &state) const
| apply the OpenGL state attributes.

## Protected Member Functions

virtual | ~TexEnv (void)

## Protected Attributes

Mode | _mode
osg::Vec4 | _color

## Detailed Description

TexEnv encapsulates the OpenGL glTexEnv (texture environment) state.

## Member Enumeration Documentation

enum osg::TexEnv::Mode

Enumeration values:

  DECAL |
  MODULATE |
  BLEND |
  REPLACE |
  ADD |

## Constructor & Destructor Documentation

TexEnv::TexEnv | ( | Mode | mode = `MODULATE` | ) |

osg::TexEnv::TexEnv | ( | const TexEnv & | texenv,
|  | const CopyOp & | copyop = `CopyOp::SHALLOW_COPY`
| ) | `[inline]`

| Copy constructor using CopyOp to manage deep vs shallow copy.

TexEnv::~TexEnv | ( | void |  | ) | `[protected, virtual]`

## Member Function Documentation

void TexEnv::apply | ( | State & | state | ) | const`[virtual]`

| apply the OpenGL state attributes. The global state for the current OpenGL context is passed in to allow the StateAttribute to obtain details on the the current context and state. Implements osg::StateAttribute.

virtual int osg::TexEnv::compare | ( | const StateAttribute & | sa | ) | const`[inline, virtual]`

| Return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs. Implements osg::StateAttribute.

const Vec4& osg::TexEnv::getColor | ( |  | ) | const`[inline]`

Vec4& osg::TexEnv::getColor | ( |  | ) | `[inline]`

Mode osg::TexEnv::getMode | ( |  | ) | const`[inline]`

virtual bool osg::TexEnv::isTextureAttribute | ( |  | ) | const`[inline, virtual]`

| Return true if StateAttribute is a type which controls texturing and needs to be issued w.r.t to specific texture unit. Reimplemented from osg::StateAttribute.

osg::TexEnv::META_StateAttribute | ( | osg | ,
|  | TexEnv | ,
|  | TEXENV |
| ) |

void osg::TexEnv::setColor | ( | const Vec4 & | color | ) | `[inline]`

void osg::TexEnv::setMode | ( | Mode | mode | ) | `[inline]`

## Member Data Documentation

osg::Vec4 osg::TexEnv::_color `[protected]`

Mode osg::TexEnv::_mode `[protected]`

The documentation for this class was generated from the following files:

- TexEnv
- TexEnv.cpp